# **************************************************************************** #
#                                                                              #
#                                                         :::      ::::::::    #
#    Makefile                                           :+:      :+:    :+:    #
#                                                     +:+ +:+         +:+      #
#    By: lorenuar <lorenuar@student.s19.be>         +#+  +:+       +#+         #
#                                                 +#+#+#+#+#+   +#+            #
#    Created: 2019/11/18 15:52:03 by lorenuar          #+#    #+#              #
#    Updated: 2020/01/15 10:40:14 by lorenuar         ###   ########.fr        #
#                                                                              #
# **************************************************************************** #

# Variables
NAME = BSQ

CC = gcc
CFLAGS = -Wextra -Werror -Wall -I./include
#CFLAGS = -I./include
#CFLAGS = -Wextra -Werror -Wall -I./include -fsanitize=address

SRC := check_tab.c		\
		get_tab.c		\
		main.c			\
		split_to_tab.c	\
		utils.c			\
		find_square.c

SRCPREFIX := src/
OBJPREFIX := obj/
SRCS := $(addprefix $(SRCPREFIX), $(SRC))
OBJ := $(SRC:.c=.o)
OBJS := $(addprefix $(OBJPREFIX), $(OBJ))

.PHONY : all clean fclean re

all : exec

$(NAME) : $(OBJS)
	@echo "\x1b[0;32m+ + + Linking into $(NAME)\x1b[0m"
	$(CC) $(CFLAGS) -o $@ $^
	@echo "\x1b[1;92m= = = DONE\x1b[0m"

$(OBJS) : $(SRCS) $(HEADERS)
	@mkdir -p obj
	@echo "\x1b[0;32m+ + + Creating $(OBJS)\x1b[0m"
	$(CC) $(CFLAGS) -c $^
	mv $(OBJ) $(OBJPREFIX)

exec : $(NAME)
	./gen/tabgen.perl 1000 1000 100 > tab
	time ./$(NAME) tab

clean :
	@echo "\x1b[0;31m- - - Removing $(OBJS)\x1b[0m"
	-rm $(OBJS) $(OBJ)

fclean : clean
	@echo "\x1b[0;31m- - - Removing  $(OBJS) & $(NAME)\x1b[0m"
	-rm $(NAME)

re : fclean all
